/*
 *	Copyright (C) Performance Awareness Corporation, 1993, 1994, 1995
 *	ALL RIGHTS RESERVED WORLDWIDE.
 *
 *	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF
 *	Performance Awareness Corporation
 *	and should be treated as Confidential.
 *
 *	The copyright notice above does not evidence any
 *	actual or intended publication of such source code.
 *
 *	preVue and preVue-X are trademarks of Performance Awareness Corporation.
 */
/*
	.../preVue/include/sme/loaddef.h         (formatted 4 spaces per tab)
	
	This header file is included with the preVue-X product as an unsupported
	tool.  Although it is provided primarily for the use of Performance
	Awareness Corporation Subject Matter Experts, it may be used by any
	preVue-X licensee.  Use of the file is solely at the risk and discretion
	of the user, and Performance Awareness Corporation does not support this
	routine as part of the customer support and/or maintenance agreements.
	
	This header includes routines for controlling workload and test exit
	conditions.  It includes declarations and definitions, while the file
	loadproc.h is an inline procedure for building the load script.  These
	two header files are designed to be used for creating the workload models
	described in the SME Handbook.  See the Methodology & Toolkit sections
	of that document for a full description of their use.
*/                                                       

#ifndef	_PV_LOADDEF_H				/* avoid recursive inclusions */
#define _PV_LOADDEF_H

shared exit_flag, base_time, time_limit, load_sync;

/*
	Formula for computing load to this point based upon a load
	specification given in transactions per hour.
*/
#define	HOURLY_LOAD(LOAD)	((((time()-base_time)/MINUTES(1))*LOAD)/60)

/*
	This macro creates a compute_load function (see loadproc.h) for the
	common case of a single workload specified in transactions per hour.
*/

#define	SINGLE_HOURLY_LOAD(RATE,TARGET,ACTUAL)	func compute_load()		\
			{															\
			TARGET=HOURLY_LOAD(RATE);									\
			if (RATE > ACTUAL)											\
				{														\
				if ((RATE-ACTUAL) > _PV_WORKLOAD_WARNING)				\
					{													\
					printf("Unable to sustain full load, %d of %d.\n",	\
							ACTUAL, RATE);								\
					fprintf(stderr,										\
							"Unable to sustain full load, %d of %d.\n",	\
							ACTUAL, RATE);								\
					}													\
				ACTUAL++;												\
				return (1);												\
				}														\
			return (0);													\
			}

#endif					/* matches #ifndef _PV_LOADDEF_H at top of file */

